import sys


def assert_equal(observed, expected):
    """Compare the observed and expected results"""
    if observed == expected:
        print('.', end='')
        return True
    else:
        linenum = sys._getframe(1).f_lineno   # Get the caller's line number.
        print("\nTest at line {} FAILED:".format(linenum))
        print("- Expected:", str(expected))
        print("- But got: ", str(observed))
        return False

def run_tests():
    caller_globals = sys._getframe(1).f_globals
    results = []
    for symbol, test in caller_globals.items():
        if symbol.startswith('test_'):
            result = test()
            results.append(result)
    print('\n=', len(results), 'tests executed.')
    print('- ', sum(results), 'passed.')
    print('- ', len(results) - sum(results), 'failed.')